#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1700eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 1700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight17004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight17004xi = {
                1:'-1006x-1030y-902z',
                2:'-1020x-835y-1072z',
                3:'-1028x-1352y-33z',
                4:'-1066x-982y-888z',
                5:'-1071x-787y-1059z',
                6:'-108x-316y-1666z',
                7:'-1098x-1297y-16z',
                8:'-1120x-735y-1046z',
                9:'-1122x-930y-873z',
                10:'-113x-1138y-1257z',
                11:'-1164x-1238y0z',
                12:'-1165x-681y-1032z',
                13:'-1176x-875y-859z',
                14:'-1209x-624y-1019z',
                15:'-1228x-817y-844z',
                16:'-122x-1305y-1081z',
                17:'-1249x-564y-1005z',
                18:'-125x-1681y-220z',
                19:'-125x-570y-1596z',
                20:'-1276x-756y-829z',
                21:'-1286x-501y-991z',
                22:'-130x-325y-1663z',
                23:'-1320x-436y-977z',
                24:'-1321x-692y-814z',
                25:'-1350x-369y-963z',
                26:'-1363x-625y-799z',
                27:'-1377x-300y-949z',
                28:'-1400x-229y-935z',
                29:'-1401x-556y-784z',
                30:'-1420x-156y-921z',
                31:'-1436x-484y-769z',
                32:'-1466x-410y-754z',
                33:'-1493x-335y-739z',
                34:'-154x-333y-1659z',
                35:'-159x-578y-1590z',
                36:'-16x-250y-1681z',
                37:'-174x-1142y-1246z',
                38:'-179x-339y-1656z',
                39:'-191x-1308y-1068z',
                40:'-194x-584y-1584z',
                41:'-205x-344y-1652z',
                42:'-213x-1674y-203z',
                43:'-230x-588y-1578z',
                44:'-232x-346y-1647z',
                45:'-236x-1144y-1234z',
                46:'-260x-347y-1643z',
                47:'-262x-1306y-1055z',
                48:'-267x-589y-1571z',
                49:'-288x-345y-1639z',
                50:'-299x-1142y-1222z',
                51:'-300x-1662y-186z',
                52:'-305x-588y-1565z',
                53:'-317x-341y-1634z',
                54:'-31x-265y-1678z',
                55:'-332x-1301y-1042z',
                56:'-343x-585y-1558z',
                57:'-346x-336y-1629z',
                58:'-362x-1136y-1210z',
                59:'-36x-1682y-236z',
                60:'-375x-328y-1625z',
                61:'-382x-579y-1551z',
                62:'-387x-1646y-169z',
                63:'-3x-233y-1683z',
                64:'-403x-1291y-1028z',
                65:'-405x-318y-1620z',
                66:'-421x-571y-1544z',
                67:'-426x-1127y-1198z',
                68:'-434x-305y-1614z',
                69:'-460x-560y-1537z',
                70:'-463x-291y-1609z',
                71:'-473x-1625y-152z',
                72:'-474x-1278y-1015z',
                73:'-489x-1114y-1186z',
                74:'-48x-280y-1676z',
                75:'-492x-274y-1603z',
                76:'-499x-546y-1530z',
                77:'-520x-255y-1598z',
                78:'-538x-530y-1522z',
                79:'-53x-1129y-1269z',
                80:'-53x-1299y-1094z',
                81:'-544x-1261y-1001z',
                82:'-547x-234y-1592z',
                83:'-552x-1097y-1174z',
                84:'-558x-1599y-135z',
                85:'-574x-210y-1586z',
                86:'-577x-511y-1514z',
                87:'-599x-184y-1579z',
                88:'-614x-1077y-1162z',
                89:'-614x-1239y-987z',
                90:'-614x-490y-1507z',
                91:'-623x-157y-1573z',
                92:'-642x-1569y-118z',
                93:'-646x-127y-1567z',
                94:'-651x-466y-1499z',
                95:'-65x-581y-1702z',
                96:'-667x-95y-1560z',
                97:'-676x-1053y-1149z',
                98:'-67x-293y-1673z',
                99:'-683x-1214y-973z',
                100:'-687x-439y-1491z',
                101:'-687x-61y-1553z',
                102:'-722x-410y-1482z',
                103:'-724x-1534y-101z',
                104:'-737x-1026y-1137z',
                105:'-750x-1185y-959z',
                106:'-756x-378y-1474z',
                107:'-788x-344y-1465z',
                108:'-797x-994y-1124z',
                109:'-803x-1495y-84z',
                110:'-817x-1152y-945z',
                111:'-819x-307y-1457z',
                112:'-848x-268y-1448z',
                113:'-855x-960y-1111z',
                114:'-86x-305y-1670z',
                115:'-875x-227y-1439z',
                116:'-881x-1452y-67z',
                117:'-882x-1115y-931z',
                118:'-912x-922y-1098z',
                119:'-93x-560y-1602z',
                120:'-945x-1074y-917z',
                121:'-956x-1404y-50z',
                122:'-967x-880y-1085z'}
       
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1700eight4xi" usage = "target function for charge1700eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1700eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1700EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1700EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1700EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1700EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1700EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight17004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1700EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1700EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1700EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight17004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight17004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1700EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1700EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1700EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1700eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  